#include <bits/stdc++.h>

using namespace std;

const int max_k = 20;

pair<vector<vector<int>>, vector<vector<long long>>> calc_up(vector<int> &h) {
    vector<vector<int>> result;
    vector<vector<long long>> add;
    result.resize(max_k);
    add.resize(max_k);

    stack<pair<int, int>> st;

    vector<int> nxt;
    nxt.resize(h.size(), (int)h.size() - 1);
    st.push(make_pair(h.back(), h.size() - 1));

    for (int i = (int)h.size() - 2; i >= 0; i--) {
        while (st.top().first < h[i])
            st.pop();
        nxt[i] = st.top().second;

        st.push(make_pair(h[i], i));
    }

    for (int k = 0; k < max_k; k++) {
        result[k].resize(h.size(), (int)h.size() - 1);
        add[k].resize(h.size(), 0);
    }

    for (int i = 0; i < h.size(); i++) {
        result[0][i] = nxt[i];
        add[0][i] = (result[0][i] - i) * 1ll * h[i];
    }

    for (int k = 1; k < max_k; k++)
        for (int i = 0; i < h.size(); i++) {
            add[k][i] = add[k - 1][i] + add[k - 1][result[k - 1][i]];
            result[k][i] = result[k - 1][result[k - 1][i]];
        }
    return make_pair(result, add);
}

long long solve(vector<int> &h, vector<vector<int>> &up, vector<vector<long long>> &add, int a, int b) {
    long long ans = 0;
    for (int k = max_k - 1; k >= 0; k--)
        if (up[k][a] < b) {
            ans += add[k][a];
            a = up[k][a];
        }
    int nxt = up[0][a];
    ans += (nxt - a) * 1ll *  h[a];
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> h;
    vector<int> rev_h;
    for (int i = 1; i < n; i++) {
        int hh;
        cin >> hh;
        h.push_back(hh);
    }
    rev_h = h;
    reverse(rev_h.begin(), rev_h.end());

    h.push_back(1000000007);
    rev_h.push_back(1000000007);

    auto p1 = calc_up(h);
    auto p2 = calc_up(rev_h);

    vector<vector<int>> up = p1.first;
    vector<vector<int>> rev_up = p2.first;

    vector<vector<long long>> add = p1.second;
    vector<vector<long long>> rev_add = p2.second;


    int t;
    cin >> t;
    while (t--) {
        int a;
        int b;
        cin >> a >> b;
        swap(a, b);
        a--; b--;
        long long ans = 0;
        if (a < b)
            ans = solve(h, up, add,  a, b);
        else {
            a = n - 1 - a;
            b = n - 1 - b;
            ans = solve(rev_h, rev_up, rev_add, a, b);
        }
        cout << ans << "\n";
    }


    return 0;
}
/*
6
 1 4 2 3 5
 4
 1 6
 6 1
 2 5
 5 2

 7
 100 1 4 2 3 5
 4
 2 7
 7 2
 3 6
 6 3


  7
 0 1 4 2 3 5
 4
 2 7
 7 2
 3 6
 6 3
 */