#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double dbl;
typedef pair <int, int> pii;
#define pb push_back
#define mp make_pair

const int MAXN = 1 << 18;
const int INF = 1e9 + 100;

pii mtree[MAXN << 1];
int n, h[MAXN];
ll tree[MAXN << 1];
int push[MAXN << 1];

void build () {
	for (int i = 1; i <= n; i++) {
		mtree[i + MAXN] = mp (h[i], i);
	}
	for (int pos = MAXN - 1; pos; pos--)
		mtree[pos] = max (mtree[pos << 1], mtree[pos << 1 | 1]);
}

int getMax (int l, int r) {
	l += MAXN, r += MAXN;
	pii res = mp (0, 0);
	while (l < r) {
		if (l & 1) res = max (res, mtree[l++]);
		if (!(r & 1)) res = max (res, mtree[r--]);
		l >>= 1;
		r >>= 1;
	}	
	if (l == r) res = max (res, mtree[l]);
	return res.second;
}

void update (int v, int Tl, int Tr, int l, int r, int x) {
	if (push[v] != -1) {
		tree[v] = 1ll * (Tr - Tl + 1) * push[v];
		if (Tr != Tl) {
			push[v << 1] = push[v];
			push[v << 1 | 1] = push[v];
		}
		push[v] = -1;
	}
	if (l > r)
		return ;
	if (Tl == l && Tr == r) {
		tree[v] = 1ll * (Tr - Tl + 1) * x;
		if (Tr != Tl) {
			push[v << 1] = x;
			push[v << 1 | 1] = x;
		}
		return ;
	}
	int Tm = (Tl + Tr) >> 1;
	update (v << 1, Tl, Tm, l, min (Tm, r), x);
	update (v << 1 | 1, Tm + 1, Tr, max (l, Tm + 1), r, x);
	tree[v] = tree[v << 1] + tree[v << 1 | 1];
}

ll get (int v, int Tl, int Tr, int l, int r) {
	if (push[v] != -1) {
		tree[v] = 1ll * (Tr - Tl + 1) * push[v];
		if (Tr != Tl) {
			push[v << 1] = push[v];
			push[v << 1 | 1] = push[v];
		}
		push[v] = -1;
	}
	if (l > r)
		return 0;
	if (Tl == l && Tr == r) {
		return tree[v];
	}
	int Tm = (Tl + Tr) >> 1;
	return get (v << 1, Tl, Tm, l, min (Tm, r)) + get (v << 1 | 1, Tm + 1, Tr, max (l, Tm + 1), r);
}

ll get (int l, int r) {
	return get (1, 0, MAXN - 1, l, r);
}
void update (int l, int r, int x) {
	update (1, 0, MAXN - 1, l, r, x);
}


struct query {
	int from, to, id;
	query () {}
	query (int from, int to, int id) : from (from), to (to), id (id) {}

	bool operator < (const query &q) const {
		if (to != q.to)
			return to < q.to;
	   	return id < q.id;
	}
};

int m[MAXN], t;
vector <query> q[2];

void load () {
	cin >> n;
	n--;
	for (int i = 1; i <= n; i++)
		cin >> h[i];

	cin >> t;
	for (int i = 0; i < t; i++) {
		int from, to;
		cin >> from >> to;
		from--;
		to--;
		if (from > to) {
			q[0].pb (query (from, to, i));
		} else {
			q[1].pb (query (from, to, i));
		}
	} 
}

ll ans[MAXN];

vector <int> seq;

void foo (query it) {
	int next;
	while ( seq.back () < it.to ) {
		next = seq.back ();
		seq.pop_back ();
		update (next, seq.back () - 1, 0);
	}
	next = seq.back ();
	if (next == it.to) 
		return ;
	int cur = it.to;
    vector <int> tmp;
    while (cur < next) {
    	update (cur, m[cur] - 1, h[cur]);
    	tmp.pb (cur);	
    	cur = m[cur];
    }
	reverse (tmp.begin (), tmp.end ());
	for (auto it : tmp)
		seq.pb (it);
}

void clear () {
	memset (m, 0, sizeof (m));
	memset (tree, 0, sizeof (tree));
	memset (push, 0xff, sizeof (push));
	memset (mtree, 0, sizeof (mtree));
	seq.clear ();
}

void pre () {
	h[n + 1] = INF;
	m[n] = n + 1;
	for (int i = n - 1; i > 0; i--) {
		m[i] = i + 1;
		while (h[m[i]] <= h[i]) {
			m[i] = m[m[i]]; 
		}
	}
}

void go (vector <query> &q) {
 	clear ();	
	pre ();
	build ();
 	sort (q.begin (), q.end ());

	int cur = 1;
	while ( 1 ) {
		seq.pb (cur);
		update (cur, m[cur] - 1, h[cur]);
		if (cur == n + 1)
			break;
		cur = m[cur];			
	}
	reverse (seq.begin (), seq.end ());

	/*for (auto it : seq)
			cerr << it << ' ';
		cerr << endl;
	*/	
	for (auto it : q) {
		it.to++;
		foo (it);
	/*	for (auto it : seq)
			cerr << it << ' ';
		cerr << endl;*/
		ans[it.id] += get (it.to, it.from);
		int r = getMax (it.to, it.from);
		//cerr << r <<  endl;
		ans[it.id] += 1ll * h[r] * (m[r] - it.from - 1);				
	}
}

void solve () {
	go (q[0]);
	
	reverse (h + 1, h + n + 1);
	for (auto &it : q[1]) {
		it.from = n - it.from;
		it.to = n - it.to;
	}

	go (q[1]);

	for (int i = 0; i < t; i++)
		cout << ans[i] << '\n'; 
}

int main () {
	ios_base :: sync_with_stdio (false);
	cin.tie (NULL);

#ifdef LOCAL
	freopen ("input.txt", "r", stdin);
	freopen ("output.txt", "w", stdout);
#endif

	load ();
	solve ();

	return 0;
}
