#include <iostream>
#include <cstdlib>
#include <ctime>
#include <map>
#include <random>

using namespace std;

char COLORS[3] = {'R', 'G', 'B'};

std::random_device r;

// Choose a random mean between 1 and 6
std::default_random_engine e1(r());
std::uniform_real_distribution<double> uniform_dist(0, 3);

int get_rand() {
  double rnd = uniform_dist(e1);
  if (rnd < 1.0) {
    return 0;
  }
  if (rnd < 2.0) {
    return 1;
  }
  return 2;
}

map<int, char> coloring;
map<int, char> back_coloring;

int main() {
  srand(time(0));
  bool is_rand = (rand() & 1);
  int n, m;
  scanf("%d%d", &n, &m);
  for (int i = 0; i < m; ++i) {
    int a, b;
    scanf("%d%d", &a, &b);
    if (coloring.find(a) == coloring.end()) {
      coloring[a] = COLORS[get_rand()];
    }
    if (back_coloring.find(b) == back_coloring.end()) {
      back_coloring[b] = COLORS[get_rand()];
    }

    char c;
    if (is_rand) {
      c = coloring[a];
    } else {
      c = back_coloring[b];
    }
    printf("%c\n", c);
  }
  return 0;
}