#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)

using namespace std;

const int N = 200000;
const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;
const int MOD1 = (int)1e9 + 9;
const int P = 239;

struct Stack
{
    vector<ll> a, last, sum;

    Stack()
    {
        a.push_back(inf);
        last.push_back(-1);
        sum.push_back(0);
    }

    void add(int h, int pos)
    {
        while (a.back() <= h)
        {
            a.pop_back();
            last.pop_back();
            sum.pop_back();
        }
        a.push_back(h);
        sum.push_back(sum.back() + (ll)h * (pos - last.back()));
        last.push_back(pos);
    }

    ll get(int x) // [x, pos]
    {
        int p = lower_bound(last.begin(), last.end(), x) - last.begin();
        return a[p] * (last[p] - x + 1) + (sum.back() - sum[p]);
    }
};

vector<ll> solve(vector<int> h, vector<pair<int, int> > QQ)
{
    //for (auto it : QQ)
    //    cout << it.fi << " " << it.se << endl;
    int n = sz(h), q = sz(QQ);
    vector<pair<pair<int, int>, int> > Q(q);
    rep(i, 0, q)
        Q[i] = {QQ[i], i};
    sort(Q.begin(), Q.end(), [](auto &p1, auto &p2) { return p1.fi.se < p2.fi.se; });
    vector<ll> ans(q);

    Stack st;
    int last = -1;
    rep(i, 0, q)
    {
        while (last < Q[i].fi.se)
        {
            st.add(h[last + 1], last + 1);
            last++;
        }
        ans[Q[i].se] = st.get(Q[i].fi.fi);
    }
    return ans;
}

int ans[N];

int log_2[N];
int st[18][N];

void build(vector<int> h)
{
    int n = sz(h);
    log_2[1] = 0;
    rep(i, 2, n + 1)
        if ((1 << (log_2[i - 1] + 1)) <= i)
            log_2[i] = log_2[i - 1] + 1;
        else
            log_2[i] = log_2[i - 1];
    int sz = 0;
    while ((1 << sz) <= n)
        sz++;
    rep(i, 0, n)
        st[0][i] = h[i];
    rep(j, 1, sz)
        rep(i, 0, n - (1 << j) + 1)
            st[j][i] = max(st[j - 1][i], st[j - 1][i + (1 << (j - 1))]);
}

int get(int l, int r)
{
    int len = log_2[r - l];
    return max(st[len][l], st[len][r - (1 << len)]);
}

int main()
{
    //freopen("a.in", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    int n;
    cin >> n;
    vector<int> h(n - 1);
    rep(i, 0, n - 1)
        cin >> h[i];
    int q;
    cin >> q;
    vector<pair<int, int> > Q;
    vector<pair<pair<int, int>, int> > Q1, Q2;
    vector<int> h1 = h, h2 = h;
    reverse(h2.begin(), h2.end());
    rep(i, 0, q)
    {
        int s, t;
        cin >> s >> t; s--; t--;
        Q.push_back({s, t});
        if (s < t)
        {
            int l = s, r = t - 1;
            Q1.push_back({{l, r}, i});
        }
        else
        {
            int l = (n - 1) - s, r = (n - 1) - (t + 1);
            Q2.push_back({{l, r}, i});
        }
    }
    vector<pair<int, int> > QQ1, QQ2;
    for (auto it : Q1)
        QQ1.push_back(it.fi);
    for (auto it : Q2)
        QQ2.push_back(it.fi);
    vector<ll> ans1 = solve(h1, QQ1);
    vector<ll> ans2 = solve(h2, QQ2);
    vector<ll> ans(q);
    build(h);

    rep(T, 0, sz(Q1))
    {
        int id = Q1[T].se;
        int s = Q[id].fi, t = Q[id].se;
        ans[id] = ans1[T];

        int height = get(s, t);
        //cout << s << " " << t << " " << height << endl;

        int l = -1, r = s, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (get(mid, s) > height)
                l = mid;
            else
                r = mid;
        }
        ans[id] += (ll)height * (s - r);
    }
    rep(T, 0, sz(Q2))
    {
        int id = Q2[T].se;
        int s = Q[id].fi, t = Q[id].se;
        ans[id] = ans2[T];

        int height = get(t, s);

        int l = s, r = n, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (get(s, mid) > height)
                r = mid;
            else
                l = mid;
        }
        ans[id] += (ll)height * (l - s);
    }
    rep(i, 0, q)
        //cout << Q[i].fi + 1 << " " << Q[i].se + 1 << " " << ans[i] << "\n";
        cout << ans[i] << "\n";
    return 0;
}
